## mongodb 2.2.4

=== SConstruct ===
# -*- mode: python; -*-
# build file for MongoDB
# this requires scons
# you can get from http://www.scons.org
# then just type scons

# some common tasks
#   build 64-bit mac and pushing to s3
#      scons --64 s3dist
#      scons --distname=0.8 s3dist
#      all s3 pushes require settings.py and simples3

# This file, SConstruct, configures the build environment, and then delegates to
# several, subordinate SConscript files, which describe specific build rules.

import buildscripts
import buildscripts.bb
import datetime
import imp
import os
import re
import shutil
import stat
import sys
import types
import urllib
import urllib2
from buildscripts import utils
from buildscripts import moduleconfig

import libdeps

EnsureSConsVersion( 1, 1, 0 )
if "uname" in dir(os):
    scons_data_dir = ".scons/%s/%s" % ( os.uname()[0] , os.getenv( "HOST" , "nohost" ) )
else:
    scons_data_dir = ".scons/%s/" % os.getenv( "HOST" , "nohost" )
SConsignFile( scons_data_dir + "/sconsign" )

DEFAULT_INSTALL_DIR = "/usr/local"

def _rpartition(string, sep):
    """A replacement for str.rpartition which is missing in Python < 2.5
    """
    idx = string.rfind(sep)
    if idx == -1:
        return '', '', string
    return string[:idx], sep, string[idx + 1:]



buildscripts.bb.checkOk()

def findSettingsSetup():
    sys.path.append( "." )
    sys.path.append( ".." )
    sys.path.append( "../../" )


# --- options ----

options = {}

options_topass = {}

def add_option( name, help, nargs, contributesToVariantDir,
                dest=None, default = None, type="string", choices=None ):

    if dest is None:
        dest = name

    AddOption( "--" + name , 
               dest=dest,
               type=type,
               nargs=nargs,
               action="store",
               choices=choices,
               default=default,
               help=help )

    options[name] = { "help" : help ,
                      "nargs" : nargs ,
                      "contributesToVariantDir" : contributesToVariantDir ,
                      "dest" : dest,
                      "default": default }

def get_option( name ):
    return GetOption( name )

def _has_option( name ):
    x = get_option( name )
    if x is None:
        return False

    if x == False:
        return False

    if x == "":
        return False

    return True

def has_option( name ):
    x = _has_option(name)

    if name not in options_topass:
        # if someone already set this, don't overwrite
        options_topass[name] = x

    return x

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

def get_variant_dir():
    
    a = []
    
    for name in options:
        o = options[name]
        if not has_option( o["dest"] ):
            continue
        if not o["contributesToVariantDir"]:
            continue
        if get_option(o["dest"]) == o["default"]:
            continue
        
        if o["nargs"] == 0:
            a.append( name )
        else:
            x = get_option( name )
            x = re.sub( "[,\\\\/]" , "_" , x )
            a.append( name + "_" + x )
            
    s = "#build/${PYSYSPLATFORM}/"

    if len(a) > 0:
        a.sort()
        s += "/".join( a ) + "/"
    else:
        s += "normal/"
    return s
        
# build output
add_option( "mute" , "do not display commandlines for compiling and linking, to reduce screen noise", 0, False )

# installation/packaging
add_option( "prefix" , "installation prefix" , 1 , False, default=DEFAULT_INSTALL_DIR )
add_option( "distname" , "dist name (0.8.0)" , 1 , False )
add_option( "distmod", "additional piece for full dist name" , 1 , False )
add_option( "nostrip", "do not strip installed binaries" , 0 , False )

add_option( "sharedclient", "build a libmongoclient.so/.dll" , 0 , False )
add_option( "full", "include client and headers when doing scons install", 0 , False )

# linking options
add_option( "release" , "release build" , 0 , True )
add_option( "static" , "fully static build" , 0 , True )

# base compile flags
add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
add_option( "32" , "whether to force 32 bit" , 0 , True , "force32" )

add_option( "cxx", "compiler to use" , 1 , True )
add_option( "cc", "compiler to use for c" , 1 , True )

add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , True )
add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , True )

add_option( "extrapath", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking" , 1 , True )
add_option( "extrapathdyn", "comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) dynamic linking" , 1 , True )
add_option( "extralib", "comma separated list of libraries  (--extralib js_static,readline" , 1 , True )

add_option( "boost-compiler", "compiler used for boost (gcc41)" , 1 , True , "boostCompiler" )
add_option( "boost-version", "boost version for linking(1_38)" , 1 , True , "boostVersion" )

add_option( "no-glibc-check" , "don't check for new versions of glibc" , 0 , False )

# experimental features
add_option( "mm", "use main memory instead of memory mapped files" , 0 , True )
add_option( "asio" , "Use Asynchronous IO (NOT READY YET)" , 0 , True )
add_option( "ssl" , "Enable SSL" , 0 , True )

# library choices
add_option( "usesm" , "use spider monkey for javascript" , 0 , True )
add_option( "usev8" , "use v8 for javascript" , 0 , True )

# mongo feature options
add_option( "noshell", "don't build shell" , 0 , True )
add_option( "safeshell", "don't let shell scripts run programs (still, don't run untrusted scripts)" , 0 , True )
add_option( "win2008plus", "use newer operating system API features" , 0 , False )

# dev options
add_option( "d", "debug build no optimization, etc..." , 0 , True , "debugBuild" )
add_option( "dd", "debug build no optimization, additional debug logging, etc..." , 0 , True , "debugBuildAndLogging" )
add_option( "durableDefaultOn" , "have durable default to on" , 0 , True )
add_option( "durableDefaultOff" , "have durable default to off" , 0 , True )

add_option( "pch" , "use precompiled headers to speed up the build (experimental)" , 0 , True , "usePCH" )
add_option( "distcc" , "use distcc for distributing builds" , 0 , False )
add_option( "clang" , "use clang++ rather than g++ (experimental)" , 0 , True )

# debugging/profiling help

add_option( "allocator" , "allocator to use (tcmalloc or system)" , 1 , True,
            default=((sys.platform.startswith('linux') and (os.uname()[-1] == 'x86_64')) and
                     'tcmalloc' or 'system') )
add_option( "gdbserver" , "build in gdb server support" , 0 , True )
add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
add_option( "gcov" , "compile with flags for gcov" , 0 , True )

add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
add_option("smokeauth", "run smoke tests with --auth", 0 , False )

add_option( "use-system-tcmalloc", "use system version of tcmalloc library", 0, True )

add_option( "use-system-pcre", "use system version of pcre library", 0, True )

add_option( "use-system-boost", "use system version of boost libraries", 0, True )

add_option( "use-system-snappy", "use system version of snappy library", 0, True )

add_option( "use-system-sm", "use system version of spidermonkey library", 0, True )

add_option( "use-system-all" , "use all system libraries", 0 , True )

add_option( "use-cpu-profiler",
            "Link against the google-perftools profiler library",
            0, True )

add_option("mongod-concurrency-level", "Concurrency level, \"global\" or \"db\"", 1, True,
           type="choice", choices=["global", "db"])

add_option('client-dist-basename', "Name of the client source archive.", 1, False,
           default='mongo-cxx-driver')

# don't run configure if user calls --help
if GetOption('help'):
    Return()

# --- environment setup ---

variantDir = get_variant_dir()

def printLocalInfo():
    import sys, SCons
    print( "scons version: " + SCons.__version__ )
    print( "python version: " + " ".join( [ `i` for i in sys.version_info ] ) )

printLocalInfo()

boostLibs = [ "thread" , "filesystem" , "program_options", "system" ]

onlyServer = len( COMMAND_LINE_TARGETS ) == 0 or ( len( COMMAND_LINE_TARGETS ) == 1 and str( COMMAND_LINE_TARGETS[0] ) in [ "mongod" , "mongos" , "test" ] )
nix = False
linux = False
linux64  = False
darwin = False
windows = False
freebsd = False
openbsd = False
solaris = False
force32 = has_option( "force32" ) 
force64 = has_option( "force64" )
if not force64 and not force32 and os.getcwd().endswith( "mongo-64" ):
    force64 = True
    print( "*** assuming you want a 64-bit build b/c of directory *** " )
msarch = None
if force32:
    msarch = "x86"
elif force64:
    msarch = "amd64"

release = has_option( "release" )
static = has_option( "static" )

debugBuild = has_option( "debugBuild" ) or has_option( "debugBuildAndLogging" ) 
debugLogging = has_option( "debugBuildAndLogging" )
noshell = has_option( "noshell" ) 

usesm = has_option( "usesm" )
usev8 = has_option( "usev8" ) 

asio = has_option( "asio" )

usePCH = has_option( "usePCH" )

justClientLib = (COMMAND_LINE_TARGETS == ['mongoclient'])

env = Environment( BUILD_DIR=variantDir,
                   CLIENT_ARCHIVE='${CLIENT_DIST_BASENAME}${DIST_ARCHIVE_SUFFIX}',
                   CLIENT_DIST_BASENAME=get_option('client-dist-basename'),
                   CLIENT_LICENSE='#distsrc/client/LICENSE.txt',
                   CLIENT_SCONSTRUCT='#distsrc/client/SConstruct',
                   DIST_ARCHIVE_SUFFIX='.tgz',
                   EXTRAPATH=get_option("extrapath"),
                   MODULE_BANNERS=[],
                   MODULETEST_LIST='#build/moduletests.txt',
                   MSVS_ARCH=msarch ,
                   PYTHON=utils.find_python(),
                   SERVER_ARCHIVE='${SERVER_DIST_BASENAME}${DIST_ARCHIVE_SUFFIX}',
                   TARGET_ARCH=msarch ,
                   tools=["default", "gch", "jsheader", "mergelib", "unittest"],
                   UNITTEST_ALIAS='unittests',
                   UNITTEST_LIST='#build/unittests.txt',
                   PYSYSPLATFORM=os.sys.platform,

                   PCRE_VERSION='8.30',
                   CONFIGUREDIR = '#' + scons_data_dir + '/sconf_temp',
                   CONFIGURELOG = '#' + scons_data_dir + '/config.log'
                   )

env['_LIBDEPS'] = '$_LIBDEPS_OBJS'

if has_option('mute'):
    env.Append( CCCOMSTR = "Compiling $TARGET" )
    env.Append( CXXCOMSTR = env["CCCOMSTR"] )
    env.Append( LINKCOMSTR = "Linking $TARGET" )
    env.Append( ARCOMSTR = "Generating library $TARGET" )

if has_option('mongod-concurrency-level'):
    env.Append(CPPDEFINES=['MONGOD_CONCURRENCY_LEVEL=MONGOD_CONCURRENCY_LEVEL_%s' % get_option('mongod-concurrency-level').upper()])

libdeps.setup_environment( env )

if env['PYSYSPLATFORM'] == 'linux3':
    env['PYSYSPLATFORM'] = 'linux2'
if 'freebsd' in env['PYSYSPLATFORM']:
    env['PYSYSPLATFORM'] = 'freebsd'

if os.sys.platform == 'win32':
    env['OS_FAMILY'] = 'win'
else:
    env['OS_FAMILY'] = 'posix'

if has_option( "cxx" ):
    env["CC"] = get_option( "cxx" )
    env["CXX"] = get_option( "cxx" )
elif has_option("clang"):
    env["CC"] = 'clang'
    env["CXX"] = 'clang++'

if has_option( "cc" ):
    env["CC"] = get_option( "cc" )

if env['PYSYSPLATFORM'] in ('linux2', 'freebsd'):
    env['LINK_LIBGROUP_START'] = '-Wl,--start-group'
    env['LINK_LIBGROUP_END'] = '-Wl,--end-group'
    env['RELOBJ_LIBDEPS_START'] = '--whole-archive'
    env['RELOBJ_LIBDEPS_END'] = '--no-whole-archive'
    env['RELOBJ_LIBDEPS_ITEM'] = ''
elif env['PYSYSPLATFORM'] == 'darwin':
    env['RELOBJFLAGS'] = [ '-arch', '$PROCESSOR_ARCHITECTURE' ]
    env['LINK_LIBGROUP_START'] = ''
    env['LINK_LIBGROUP_END'] = ''

=== distsrc/client/SConstruct ===
# -*- mode: python -*-

# scons file for MongoDB c++ client library and examples

import os
import sys

# options
AddOption("--extrapath",
          dest="extrapath",
          type="string",
          nargs=1,
          action="store",
          help="comma separated list of add'l paths  (--extrapath /opt/foo/,/foo) static linking")

AddOption("--prefix",
          dest="prefix",
          type="string",
          nargs=1,
          action="store",
          default="/usr/local",
          help="installation root")


env = Environment(BUILD_DIR='#build',
                  CLIENT_ARCHIVE='${CLIENT_DIST_BASENAME}${DIST_ARCHIVE_SUFFIX}',
                  CLIENT_DIST_BASENAME='mongo-cxx-driver',
                  CLIENT_LICENSE='#LICENSE.txt',
                  CLIENT_SCONSTRUCT='#SConstruct',
                  MSVS_ARCH=None,
                  PYTHON=sys.executable)

def addExtraLibs(s):
    for x in s.split(","):
        if os.path.exists(x):
            env.Append(CPPPATH=[x + "/include", x],
                       LIBPATH=[x + "/lib", x + "/lib64"])

if GetOption( "extrapath" ) is not None:
    addExtraLibs( GetOption( "extrapath" ) )

env.Prepend(CPPPATH=["$BUILD_DIR", "$BUILD_DIR/mongo"])
env.Append(CPPDEFINES=[ "_SCONS", "MONGO_EXPOSE_MACROS" ])

nix = False
linux = False
win = False

if "darwin" == sys.platform:
    addExtraLibs( "/opt/local/" )
    nix = True
elif sys.platform in ("linux2", "linux3"):
    nix = True
    linux = True
elif sys.platform == 'win32':
    win = True

if win:
    env['DIST_ARCHIVE_SUFFIX'] = '.zip'
    env.Append(CCFLAGS=['/EHsc', '/O2'])
else:
    env['DIST_ARCHIVE_SUFFIX'] = '.tgz'

if nix:
    env.Append(CCFLAGS=["-O3", "-pthread"])
if linux:
    env.Append(LINKFLAGS=["-Wl,--as-needed", "-Wl,-zdefs", "-pthread"])

boostLibs = ["thread", "filesystem", "system"]
conf = Configure(env)
for lib in boostLibs:
    if not conf.CheckLib(["boost_%s-mt" % lib, "boost_%s" % lib],
                         language="C++"):
        if not win:
            Exit(1)
conf.Finish()

clientEnv = env.Clone()
clientEnv['CPPDEFINES'].remove('MONGO_EXPOSE_MACROS')

Export("env clientEnv")
env.SConscript('src/SConscript.client', variant_dir='$BUILD_DIR', duplicate=False)

mongoclient = env.Alias('mongoclient', ['${LIBPREFIX}mongoclient${LIBSUFFIX}'])
env.Default(mongoclient)


# install
env.Alias("install", GetOption('prefix'))

=== debian/changelog ===
mongodb (1:2.2.4-0ubuntu1) raring; urgency=low

  * New upstream final bugfix release.

 -- James Page <james.page@ubuntu.com>  Fri, 05 Apr 2013 14:42:54 +0100

=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
Uploaders: Roberto C. Sanchez <roberto@connexer.com>, Jérémy Lal <kapouer@melix.org>
Build-Depends: debhelper (>= 9), cdbs (>= 0.4.73~), libpcre3, libpcre3-dev, scons, libreadline-dev, libboost-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-program-options-dev, libboost-date-time-dev, python-pymongo, libsnappy-dev, libgoogle-perftools-dev [amd64 i386], libssl-dev
Standards-Version: 3.9.3
Vcs-Git: git://github.com/bobek/mongo-debian.git
Vcs-Browser: https://github.com/bobek/mongo-debian
Homepage: http://www.mongodb.org

Package: mongodb
Architecture: i386 amd64 armhf
Depends: mongodb-server, mongodb-dev, ${shlibs:Depends}, ${misc:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a metapackage that depends on all the mongodb parts.

Package: mongodb-server
Architecture: i386 amd64 armhf
Depends: mongodb-clients, ${shlibs:Depends}, ${misc:Depends}, adduser
Replaces: mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself.

Package: mongodb-clients
Architecture: i386 amd64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the various client applications.

Package: mongodb-dev
Section: libdevel
Architecture: i386 amd64 armhf
Depends: libboost-dev, ${shlibs:Depends}, ${misc:Depends}
Suggests: mongodb-server
Replaces: mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (development)
 MongoDB is a high-performance, open source, schema-free
 document-oriented  data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features :
 .
    * Collection oriented storage - easy storage of object-
      style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large
      objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 Development headers and libraries.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DH_INSTALLINIT_ARGS = --name=mongodb

DEB_SCONS_OPTIONS :=

# Ubuntu specific build options
ifeq ($(shell dpkg-vendor --derives-from ubuntu && echo ubuntu),ubuntu)
# Don't strip binaries - this is handled automatically in ubuntu
DEB_SCONS_OPTIONS += --nostrip

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libboost-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --use-system-boost
endif #boost

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libpcre3-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --use-system-pcre
endif #pcre

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libssl-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --ssl
endif #ssl

ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libsnappy-dev([[:space:]]|,|$$)' debian/control),1)
	DEB_SCONS_OPTIONS += --use-system-snappy
endif #snappy

ifeq ($(filter armhf, $(DEB_HOST_ARCH)),)
ifeq ($(shell grep -c -E '^Build-Depends:(.*,)?[[:space:]]*libgoogle-perftools-dev([[:space:]]|,|$$)' debian/control),1)
	# Enable gperftools on x86 archs
	DEB_SCONS_OPTIONS += --allocator=tcmalloc --use-system-tcmalloc
endif #gperftools
endif #!armhf

endif #ubuntu

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
	PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS += -j$(PROCS)
endif

DEB_SCONS_BUILD_TARGET = all
DEB_SCONS_INSTALL_OPTIONS += --prefix=$(CURDIR)/debian/tmp/usr --full
DEB_SCONS_CHECK_TARGET = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke

clean::
	find . -name "*.pyc" -delete
	rm -f buildinfo.cpp
	rm -rf debian/tmp-test
	rm -rf .scons

## mongodb 2.4.3

=== SConstruct ===
--- 
+++ 
@@ -14,7 +14,6 @@
 # several, subordinate SConscript files, which describe specific build rules.
 
 import buildscripts
-import buildscripts.bb
 import datetime
 import imp
 import os
@@ -39,17 +38,6 @@
 
 DEFAULT_INSTALL_DIR = "/usr/local"
 
-def _rpartition(string, sep):
-    """A replacement for str.rpartition which is missing in Python < 2.5
-    """
-    idx = string.rfind(sep)
-    if idx == -1:
-        return '', '', string
-    return string[:idx], sep, string[idx + 1:]
-
-
-
-buildscripts.bb.checkOk()
 
 def findSettingsSetup():
     sys.path.append( "." )
@@ -129,7 +117,7 @@
             a.append( name )
         else:
             x = get_option( name )
-            x = re.sub( "[,\\\\/]" , "_" , x )
+            x = re.sub( "[:,\\\\/]" , "_" , x )
             a.append( name + "_" + x )
             
     s = "#build/${PYSYSPLATFORM}/"
@@ -155,7 +143,8 @@
 
 # linking options
 add_option( "release" , "release build" , 0 , True )
-add_option( "static" , "fully static build" , 0 , True )
+add_option( "static" , "fully static build" , 0 , False )
+add_option( "static-libstdc++" , "statically link libstdc++" , 0 , False )
 
 # base compile flags
 add_option( "64" , "whether to force 64 bit" , 0 , True , "force64" )
@@ -163,6 +152,7 @@
 
 add_option( "cxx", "compiler to use" , 1 , True )
 add_option( "cc", "compiler to use for c" , 1 , True )
+add_option( "ld", "linker to use" , 1 , True )
 
 add_option( "cpppath", "Include path if you have headers in a nonstandard directory" , 1 , True )
 add_option( "libpath", "Library path if you have libraries in a nonstandard directory" , 1 , True )
@@ -201,10 +191,14 @@
 add_option( "clang" , "use clang++ rather than g++ (experimental)" , 0 , True )
 
 # debugging/profiling help
-
+if os.sys.platform.startswith("linux") and (os.uname()[-1] == 'x86_64'):
+    defaultAllocator = 'tcmalloc'
+elif (os.sys.platform == "darwin") and (os.uname()[-1] == 'x86_64'):
+    defaultAllocator = 'tcmalloc'
+else:
+    defaultAllocator = 'system'
 add_option( "allocator" , "allocator to use (tcmalloc or system)" , 1 , True,
-            default=((sys.platform.startswith('linux') and (os.uname()[-1] == 'x86_64')) and
-                     'tcmalloc' or 'system') )
+            default=defaultAllocator )
 add_option( "gdbserver" , "build in gdb server support" , 0 , True )
 add_option( "heapcheck", "link to heap-checking malloc-lib and look for memory leaks during tests" , 0 , False )
 add_option( "gcov" , "compile with flags for gcov" , 0 , True )
@@ -212,6 +206,8 @@
 add_option("smokedbprefix", "prefix to dbpath et al. for smoke tests", 1 , False )
 add_option("smokeauth", "run smoke tests with --auth", 0 , False )
 
+add_option("use-sasl-client", "Support SASL authentication in the client library", 0, False)
+
 add_option( "use-system-tcmalloc", "use system version of tcmalloc library", 0, True )
 
 add_option( "use-system-pcre", "use system version of pcre library", 0, True )
@@ -221,12 +217,13 @@
 add_option( "use-system-snappy", "use system version of snappy library", 0, True )
 
 add_option( "use-system-sm", "use system version of spidermonkey library", 0, True )
+add_option( "use-system-v8", "use system version of v8 library", 0, True )
 
 add_option( "use-system-all" , "use all system libraries", 0 , True )
 
 add_option( "use-cpu-profiler",
             "Link against the google-perftools profiler library",
-            0, True )
+            0, False )
 
 add_option("mongod-concurrency-level", "Concurrency level, \"global\" or \"db\"", 1, True,
            type="choice", choices=["global", "db"])
@@ -295,6 +292,10 @@
                    DIST_ARCHIVE_SUFFIX='.tgz',
                    EXTRAPATH=get_option("extrapath"),
                    MODULE_BANNERS=[],
+                   MODULE_LIBDEPS_MONGOD=[],
+                   MODULE_LIBDEPS_MONGOS=[],
+                   MODULE_LIBDEPS_MONGOSHELL=[],
+                   MODULETEST_ALIAS='moduletests',
                    MODULETEST_LIST='#build/moduletests.txt',
                    MSVS_ARCH=msarch ,
                    PYTHON=utils.find_python(),
@@ -343,13 +344,7 @@
 if has_option( "cc" ):
     env["CC"] = get_option( "cc" )
 
+if has_option( "ld" ):
+    env["LINK"] = get_option( "ld" )
+
 if env['PYSYSPLATFORM'] in ('linux2', 'freebsd'):
-    env['LINK_LIBGROUP_START'] = '-Wl,--start-group'
-    env['LINK_LIBGROUP_END'] = '-Wl,--end-group'
-    env['RELOBJ_LIBDEPS_START'] = '--whole-archive'
-    env['RELOBJ_LIBDEPS_END'] = '--no-whole-archive'
-    env['RELOBJ_LIBDEPS_ITEM'] = ''
-elif env['PYSYSPLATFORM'] == 'darwin':
-    env['RELOBJFLAGS'] = [ '-arch', '$PROCESSOR_ARCHITECTURE' ]
-    env['LINK_LIBGROUP_START'] = ''
-    env['LINK_LIBGROUP_END'] = ''

=== distsrc/client/SConstruct ===
--- 
+++ 
@@ -73,6 +73,10 @@
                          language="C++"):
         if not win:
             Exit(1)
+
+env['MONGO_BUILD_SASL_CLIENT'] = conf.CheckLibWithHeader(
+    "gsasl", "gsasl.h", "C", "gsasl_check_version(GSASL_VERSION);", autoadd=False)
+
 conf.Finish()
 
 clientEnv = env.Clone()

## mongodb 2.4.5

=== SConstruct ===
--- 
+++ 
@@ -311,40 +311,21 @@
                    CONFIGURELOG = '#' + scons_data_dir + '/config.log'
                    )
 
+# This could be 'if solaris', but unfortuantely that variable hasn't been set yet.
+if "sunos5" == os.sys.platform:
+    # SERVER-9890: On Solaris, SCons preferentially loads the sun linker tool 'sunlink' when
+    # using the 'default' tools as we do above. The sunlink tool sets -G as the flag for
+    # creating a shared library. But we don't want that, since we always drive our link step
+    # through CC or CXX. Instead, we want to let the compiler map GCC's '-shared' flag to the
+    # appropriate linker specs that it has compiled in. We could (and should in the future)
+    # select an empty set of tools above and then enable them as appropriate on a per platform
+    # basis. Until then the simplest solution, as discussed on the scons-users mailing list,
+    # appears to be to simply explicitly run the 'gnulink' tool to overwrite the Environment
+    # changes made by 'sunlink'. See the following thread for more detail:
+    #  http://four.pairlist.net/pipermail/scons-users/2013-June/001486.html
+    env.Tool('gnulink')
+
+
 env['_LIBDEPS'] = '$_LIBDEPS_OBJS'
 
 if has_option('mute'):
-    env.Append( CCCOMSTR = "Compiling $TARGET" )
-    env.Append( CXXCOMSTR = env["CCCOMSTR"] )
-    env.Append( LINKCOMSTR = "Linking $TARGET" )
-    env.Append( ARCOMSTR = "Generating library $TARGET" )
-
-if has_option('mongod-concurrency-level'):
-    env.Append(CPPDEFINES=['MONGOD_CONCURRENCY_LEVEL=MONGOD_CONCURRENCY_LEVEL_%s' % get_option('mongod-concurrency-level').upper()])
-
-libdeps.setup_environment( env )
-
-if env['PYSYSPLATFORM'] == 'linux3':
-    env['PYSYSPLATFORM'] = 'linux2'
-if 'freebsd' in env['PYSYSPLATFORM']:
-    env['PYSYSPLATFORM'] = 'freebsd'
-
-if os.sys.platform == 'win32':
-    env['OS_FAMILY'] = 'win'
-else:
-    env['OS_FAMILY'] = 'posix'
-
-if has_option( "cxx" ):
-    env["CC"] = get_option( "cxx" )
-    env["CXX"] = get_option( "cxx" )
-elif has_option("clang"):
-    env["CC"] = 'clang'
-    env["CXX"] = 'clang++'
-
-if has_option( "cc" ):
-    env["CC"] = get_option( "cc" )
-
-if has_option( "ld" ):
-    env["LINK"] = get_option( "ld" )
-
-if env['PYSYSPLATFORM'] in ('linux2', 'freebsd'):

=== distsrc/client/SConstruct ===
--- 
+++ 
@@ -22,13 +22,27 @@
           help="installation root")
 
 
+# Stub out has_option so that we can use it in SConscript.client
+def has_option(name):
+    return False
+
+# Stub out use_system_version_of_library so we can use it in SConscript.client
+def use_system_version_of_library(name):
+    return True
+
 env = Environment(BUILD_DIR='#build',
                   CLIENT_ARCHIVE='${CLIENT_DIST_BASENAME}${DIST_ARCHIVE_SUFFIX}',
                   CLIENT_DIST_BASENAME='mongo-cxx-driver',
                   CLIENT_LICENSE='#LICENSE.txt',
                   CLIENT_SCONSTRUCT='#SConstruct',
                   MSVS_ARCH=None,
-                  PYTHON=sys.executable)
+                  PYTHON=sys.executable,
+                  PYSYSPLATFORM=os.sys.platform)
+
+if env['PYSYSPLATFORM'] == 'linux3':
+    env['PYSYSPLATFORM'] = 'linux2'
+if 'freebsd' in env['PYSYSPLATFORM']:
+    env['PYSYSPLATFORM'] = 'freebsd'
 
 def addExtraLibs(s):
     for x in s.split(","):
@@ -44,18 +58,20 @@
 
 nix = False
 linux = False
-win = False
+windows = False
+darwin = False
 
 if "darwin" == sys.platform:
     addExtraLibs( "/opt/local/" )
     nix = True
+    darwin = True
 elif sys.platform in ("linux2", "linux3"):
     nix = True
     linux = True
 elif sys.platform == 'win32':
-    win = True
+    windows = True
 
-if win:
+if windows:
     env['DIST_ARCHIVE_SUFFIX'] = '.zip'
     env.Append(CCFLAGS=['/EHsc', '/O2'])
 else:
@@ -64,25 +80,29 @@
 if nix:
     env.Append(CCFLAGS=["-O3", "-pthread"])
 if linux:
-    env.Append(LINKFLAGS=["-Wl,--as-needed", "-Wl,-zdefs", "-pthread"])
+    env.Append(LINKFLAGS=["-pthread"])
 
 boostLibs = ["thread", "filesystem", "system"]
 conf = Configure(env)
 for lib in boostLibs:
     if not conf.CheckLib(["boost_%s-mt" % lib, "boost_%s" % lib],
                          language="C++"):
-        if not win:
+        if not windows:
             Exit(1)
 
 env['MONGO_BUILD_SASL_CLIENT'] = conf.CheckLibWithHeader(
-    "gsasl", "gsasl.h", "C", "gsasl_check_version(GSASL_VERSION);", autoadd=False)
+    "sasl2", "sasl/sasl.h", "C", "sasl_version_info(0, 0, 0, 0, 0, 0);", autoadd=False)
 
 conf.Finish()
 
-clientEnv = env.Clone()
-clientEnv['CPPDEFINES'].remove('MONGO_EXPOSE_MACROS')
+class InstallSetup:
+    binaries = False
+    libraries = False
+    headers = False
+installSetup = InstallSetup()
 
-Export("env clientEnv")
+Export("env has_option use_system_version_of_library installSetup")
+Export("nix linux windows darwin")
 env.SConscript('src/SConscript.client', variant_dir='$BUILD_DIR', duplicate=False)
 
 mongoclient = env.Alias('mongoclient', ['${LIBPREFIX}mongoclient${LIBSUFFIX}'])

=== debian/changelog ===
mongodb (1:2.4.5-1ubuntu2) saucy; urgency=low

  * d/control,rules: Use system libv8 for armhf architecture as embedded
    version does not support ARM. 

 -- James Page <james.page@ubuntu.com>  Wed, 14 Aug 2013 15:53:25 +0100

mongodb (1:2.4.5-1ubuntu1) saucy; urgency=low

  * Merge from Debian unstable, remaining changes:
    - Enable SSL support:
      + d/control: Add libssl-dev to BD's.
      + d/rules: Enabled --ssl option.
      + d/mongodb.conf: Add example SSL configuration options.
    - d/mongodb-server.mongodb.upstart: Add upstart configuration.
    - d/rules: Don't strip binaries during scons build for Ubuntu.
    - d/control: Add armhf to target archs.
    - d/p/0008-ignore-unused-local-typedefs.patch: Add -Wno-unused-typedefs
      to unbreak building with g++-4.8.
    - d/p/0009-boost-1.53.patch: Fixup signed/unsigned casting issue.
    - d/p/0010-install-libs-to-usr-lib-not-usr-lib64-Closes-588557.patch:
      Install libraries to lib not lib64.
    - d/p/0011-Use-a-signed-char-to-store-BSONType-enumerations.patch: Fixup
      build failure on ARM due to missing signed'ness of char cast.
  * Dropped changes, no longer required:
    - d/p/SConscript.client.patch: fixup install of client libraries.
  * d/rules,control: Switch back to using gcc/g++ 4.8 as we have appropriate
    fixes in the Ubuntu delta.
  * d/mongodb-server.mongodb.upstart: Sync changes from upstream packaging
    upstart configuration, specifically;
    - increase nofile limits to 20000/20000.
    - wait 300s between SIGTERM and SIGKILL.

 -- James Page <james.page@ubuntu.com>  Wed, 07 Aug 2013 13:21:03 +0100

mongodb (1:2.4.5-1) unstable; urgency=critical

  * new upstream release
    https://jira.mongodb.org/browse/SERVER/fixforversion/12519
  * CVE-2013-4650 - fix allows remote authenticated users to obtain
    internal system privileges (Closes: #715007).
  * CVE-2013-2132 and CVE-2013-4142 - Remotely triggered segmentation
    fault in Javascript engine (Closes: #717173).
  * Force use of TIME_UTC_ boost macro (Closes: #710639).
  * Use gcc and g++ 4.7 to avoid #701324 which is still pending.
  * Remove build directory (Closes: #715015).
  * Currently uses embedded V8 as the one in Debian is too old.

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 17 Jul 2013 16:23:43 +0200

mongodb (1:2.4.3-1ubuntu1) saucy; urgency=low

  [ James Page ]
  * Merge from Debian unstable, remaining changes:
    - Enable SSL support:
      + d/control: Add libssl-dev to BD's.
      + d/rules: Enabled --ssl option.
      + d/mongodb.conf: Add example SSL configuration options.
    - d/mongodb-server.mongodb.upstart: Add upstart configuration.
    - d/rules: Don't strip binaries during scons build for Ubuntu.
    - d/control: Add armhf to target archs.
    - d/p/SConscript.client.patch: fixup install of client libraries.
    - d/p/0010-install-libs-to-usr-lib-not-usr-lib64-Closes-588557.patch:
      Install libraries to lib not lib64.
  * Dropped changes:
    - d/p/arm-support.patch: Included in Debian.
    - d/p/double-alignment.patch: Included in Debian.
    - d/rules,control: Debian also builds with avaliable system libraries
      now.
  * Fix FTBFS due to gcc and boost upgrades in saucy:
    - d/p/0008-ignore-unused-local-typedefs.patch: Add -Wno-unused-typedefs
      to unbreak building with g++-4.8.
    - d/p/0009-boost-1.53.patch: Fixup signed/unsigned casting issue.

  [ Robie Basak ]
  * d/p/0011-Use-a-signed-char-to-store-BSONType-enumerations.patch: Fixup
    build failure on ARM due to missing signed'ness of char cast.

 -- James Page <james.page@ubuntu.com>  Wed, 29 May 2013 17:44:42 +0100

mongodb (1:2.4.3-1) unstable; urgency=low

  [ Jeff Epler ]
  * [2a15682] kfreebsd does not have tcmalloc
  * [b66002a] enable building packages on kfreebsd

  [ Rogério Brito ]
  * [44bbe5b] debian/control: Make mongodb arch all, instead of
    arch-specific.
  * [50e5786] debian/patches: Add preparation for kFreeBSD.
  * [164ec3b] debian/patches: Regenerate the patches from patch queue.
    Thanks to Pino Toscano and Jeff Epler (Closes: #703061)
  * [b960dca] debian/control: Remove libpcre3 from build-depends.
  * [8e53a7e] debian/copyright: Wrap long lines.
  * [f33d197] debian/control: Make the mongodb metapackage arch-dependent.
  * [1771ce7] debian/control: Set priority of packages to extra.
  * [198f7bb] debian/control: Mark libgoogle-perftools-dev as
    linux-amd64 linux-i386.
  * [02826cb] debian/patches: Take some patches for ARM from Ubuntu.
  * [bfa912d] debian/patches: Remove patch that substituted install with
    installs.

  [ Antonin Kral ]
  * [a618d03] new upstream release
    https://jira.mongodb.org/browse/SERVER/fixforversion/12426

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 24 Apr 2013 21:10:53 +0200

mongodb (1:2.4.2-1) unstable; urgency=low

  * new upstream release
    https://jira.mongodb.org/browse/SERVER/fixforversion/12405

 -- Antonin Kral <A.Kral@sh.cvut.cz>  Wed, 17 Apr 2013 21:52:17 +0200

mongodb (1:2.4.1-3) unstable; urgency=low

  [ Rogério Brito ]
  * [ab6f6c3] debian/control: Retouch the package descriptions.
  * [d44e3d4] d/{control,copyright}: Normalize fields with wrap-and-sort.
  * [8287fd7] d/control: Add more build-deps to avoid use of embedded
              libraries.
  * [17fcb2c] d/control: Add more build-deps for compliant packages.
  * [e239a9f] debian/rules: Use as many system libraries as possible.
  * [3326d9e] Add a small note to README.Debian to document differences
              from upstream.
  * [df784a3] debian/README.source: Be more descriptive on the workflow.
  * [d85c075] debian/patches: Add patch to use the system libstemmer library.
  * [3f4c7e7] gitignore: Ignore quilt's state directory.
  * [12d4a68] Add README.Debian file to mongodb-server. (Closes: #705054)
  * [99320d3] debian/control: Augment descriptions of packages.
  * [5d10dbf] Add bsondump to the clients package. (Closes: #679018)
  * [434c5da] Add newer/more clients to the mongodb-clients package.


=== debian/control ===
Source: mongodb
Section: database
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Antonin Kral <A.Kral@sh.cvut.cz>
Uploaders:
 Roberto C. Sanchez <roberto@connexer.com>,
 Jérémy Lal <kapouer@melix.org>
Build-Depends:
 cdbs (>= 0.4.73~),
 debhelper (>= 9),
 libboost-date-time-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libgoogle-perftools-dev [linux-amd64 linux-i386],
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libstemmer-dev,
 libssl-dev,
 libv8-dev [armhf],
 python-pymongo,
 scons
Standards-Version: 3.9.3
Vcs-Git: git://github.com/bobek/mongo-debian.git
Vcs-Browser: https://github.com/bobek/mongo-debian
Homepage: http://www.mongodb.org

Package: mongodb
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 mongodb-dev,
 mongodb-server (>= 1:2.4.1-2),
 ${misc:Depends},
 ${shlibs:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a convenience metapackage that depends on all the mongodb parts:
 the server, the clients and the development files (headers and library).

Package: mongodb-server
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 adduser,
 mongodb-clients,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself.

Package: mongodb-clients
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the various client applications.

Package: mongodb-dev
Section: libdevel
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf
Depends:
 libboost-dev,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 mongodb-server
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (development)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the development headers and libraries.

## mongodb 2.4.6

=== debian/changelog ===
mongodb (1:2.4.6-0ubuntu3) saucy; urgency=low

  * debian/*: Drop upstream debian changes accidentally merged in
    1:2.4.6-0ubuntu1. 

 -- James Page <james.page@ubuntu.com>  Tue, 27 Aug 2013 15:40:16 +0100

mongodb (1:2.4.6-0ubuntu2) saucy; urgency=low

  * remove debian/mongodb.upstart (LP: #1217051) 

 -- Stephan Adig <sh@sourcecode.de>  Mon, 26 Aug 2013 20:55:28 +0200

mongodb (1:2.4.6-0ubuntu1) saucy; urgency=low

  * New upstream point release.
  * d/control,d/tests/*: Add autopkgtests for server process and client
    shell functionality.

 -- James Page <james.page@ubuntu.com>  Mon, 26 Aug 2013 09:41:32 +0100

=== debian/control ===
--- 
+++ 
@@ -28,6 +28,7 @@
 Vcs-Git: git://github.com/bobek/mongo-debian.git
 Vcs-Browser: https://github.com/bobek/mongo-debian
 Homepage: http://www.mongodb.org
+XS-Testsuite: autopkgtest
 
 Package: mongodb
 Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 armhf

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_DH_INSTALLINIT_ARGS = --name=mongodb

DEB_SCONS_OPTIONS :=
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif
ifneq (,$(findstring parallel,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

# Ubuntu specific build options
ifeq ($(shell dpkg-vendor --derives-from ubuntu && echo ubuntu),ubuntu)
# Don't strip binaries - this is handled automatically in ubuntu
DEB_SCONS_OPTIONS += --nostrip
# Enable SSL support
DEB_SCONS_OPTIONS += --ssl
endif #ubuntu

COMMON_OPTIONS = --use-system-snappy --use-system-tcmalloc --use-system-pcre --use-system-boost

ifeq ($(shell dpkg-architecture -qDEB_BUILD_ARCH),armhf)
COMMON_OPTIONS += --use-system-v8
endif

DEB_SCONS_BUILD_TARGET = all
DEB_SCONS_BUILD_OPTIONS = $(COMMON_OPTIONS)
DEB_SCONS_INSTALL_OPTIONS += --prefix=$(CURDIR)/debian/tmp/usr --full $(COMMON_OPTIONS)
DEB_SCONS_CHECK_TARGET = --smokedbprefix=$(CURDIR)/debian/tmp-test smoke $(COMMON_OPTIONS)

clean::
	find . -name "*.pyc" -delete
	rm -f buildinfo.cpp
	rm -rf debian/tmp-test
	rm -rf .scons
	rm -rf build

=== debian/tests/control ===
Tests: mongod mongo-client
Depends: mongodb-server, mongodb-clients, nmap
